<?
	/****************************************************************************************
	*                       HTTP_USER_AGENT identification class                            *
	*            (c)2003-2005 TOTH Richard, riso.toth@seznam.cz, Slovakia                   *
	*                               rev 1.9 (04.02.2005)
	*****************************************************************************************
	*          Modified by Wooya, wooya@2loud.net.pl, http://mfusion.2loud.net.pl           *
	*     (added new function GetBrowserVersion() with regexp detection and new bots)       *
	*                                      ver 0.1                                          *
	*****************************************************************************************
Operating systems:
Win3.1,
Win3.11,
Win95,
Win98,
WinME,
WinNT,
Win2000,
WinXP,
Win.NET,
Windows Vista (codename: Longhorn),
WinCE,
MacOSX,
MacPPC,
Mac68K,
LindowsOS,
Linux,
FreeBSD,
NetBSD,
Unix,
HP-UX,
SunOS,
IRIX,
OSF1,
QNX Photon,
OS/2,
Amiga,
Symbian,
Palm,
Liberate,
Sega Dreamcast,
WebTV,
PowerTV,
Prodigy,
Siemens CX35
---------------------
OS distros:
Ubuntu,

----------------------
Browsers:
Amaya,
AOL,
AWeb,
Beonex,
Camino,
Cyberdog,
Dillo,
Doris,
ELinks,
Emacs,
Firebird,
Firefox,
FrontPage,
Galeon,
Chimera,
iCab,
IBM Web Browser,
Internet Explorer,
Konqueror,
Liberate,
Links,
Lycoris Desktop/LX,
Lynx,
Netbox,
Netcaptor,
Netpliance,
Netscape,
Mozzila,
OffByOne,
Opera,
Pocket Internet Explorer,
PowerBrowser,
Phoenix,
PlanetWeb,
PowerTV,
Prodigy,
Voyager,
QuickTime,
Safari,
Sharp Reader,
Tango,
WebExplorer,
WebTV,
Yandex,
UP Browser
------------------------------
WAP browsers:
KBrowser,
Alcatel-BE3,
Alcatel-BF3,
Alcatel-BE4,
Alcatel-BF4,
Alcatel-BE5,
AUR PALM WAPPER,
EricssonA,
EricssonR,
EricssonT,
Mitsubishi,
Benefon,
Sony CMD,
Nokia,
Siemens C35
------------------------
Validators:
W3C Validator,
Jigsaw,
PHP Online Validator,
WDG_Validator
-------------------------- 
Bots: 
GoogleBot, 
GoogleBot-Image, 
MSNBot, 
SurveyBot, 
IBM  Crawler, 
Alexa, 
ZyBorg,
W3C Checklink,
LinkWalker, 
Fast WebCrawler, 
Yahoo! Slurp, 
NaverBot,
Link checker pro,
BecomeBot,
Convera Crawler,
Innerprise,
TopicSpy,
Poodle Predictort,
Ichiro,
Link Checker Pro,
Grub Client,
Gigabot,
PSBot,
MJ12Bot,
NextGenSearchBot,
TutorGigBot,
Exabot NG,
GaisBot,
Xenu Link Sleuth,
TurnnitinBot,
Iconsurf,
Zoe Indexer,
FreeDemon,
CazoodleBot Crawler,
BumbleBee,
BlitzBOT,
KIT-Fireball,
Ask Jeeves,
Indy Library,
Girafabot,
inktomi,
Robozilla,
Scooter-W3 (Altavista),
Steeler/1.3,
Szukacz,
TECOMAC-Crawler,
ABCDatos BotLink,
Acme.Spider,
Ahoy! The Homepage Finder,
AlkalineBOT,
Anthill,

------------------------------
Download Tools:
Alligator,
Download Accelerator,
Download Express,
FlashGet,
GetRight,
Go!Zilla,
WGet,
---------------------------------
Other tools:
CacheabilityEngine,
InfoLink,
-------------------------
Mailers:
Thunderbird,

****************************************************************************************/

	class BrowserInfo
	{
		var $USER_AGENT = ""; // STRING - USER_AGENT_STRING
		var $OS = ""; // STRING - operating system
		var $OS_Version = ""; // STRING - operating system version
		var $OS_Distro = ""; // STRING - operating system distribution (question: only linux?)
		var $Browser = "" ;// STRING - Browser name
		var $Browser_Version = ""; // STRING - Browser version
		var $NET_CLR = false; // BOOL - .NET Common Language Runtime
		var $Resolved = false; // BOOL - resolving proceeded
		var $Type = ""; // STRING - Browser/Robot
		
		
		
		// CONSTRUCTOR - Main function to resolving user agents
		function BrowserInfo($UA) // PUBLIC - BrowserInfo((string) USER_AGENT_STRING)
		{
			$this->USER_AGENT = $UA;
			$this->Resolve();
			$this->Resolved = true;
		}
		
		
		// FUNCTION - Resolving user agents
		function Resolve() // PUBLIC - Resolve()
		{
			$this->Resolved = false;
			$this->OS = "";
			$this->OS_Version = "";
			$this->OS_Distro = "";
			$this->NET_CLR = false;
			
			$this->_GetOperatingSystem();
			$this->_GetBrowser();
			$this->_GetNET_CLR();
		}
		
		/***********************************************************************************/
		
		// PROTECTED - _GetNET_CLR()
		function _GetNET_CLR()
		{
			if (eregi("NET CLR",$this->USER_AGENT)) {$this->NET_CLR = true;}
		}
		
		function _GetBrowserVersion ($browser) {
			//return preg_replace('@^(.*?)('.$browser.')[\s|/|:|-|=]([0-9])\.([0-9])(.*?)$@si', '\3.\4', $this->USER_AGENT);
			$pos = strpos(strtolower($this->USER_AGENT), strtolower($browser));
			if ($pos !== false) {
				$signs = array("/", "v", "ver", " ", ":", "-media", "msn2", ";");
	         $len = strlen($browser);
	         $ver = substr($this->USER_AGENT, $pos+$len, 12);
	         $ver = str_replace($signs, "", strtolower($ver));
	         $val = 0;
	         for ($i=0;$i<strlen($ver);$i++) {
	         	$occ = substr($ver, $i, 1);
	         	if (isNum($occ)) $val = $i;
	         }
	         $ver = substr($ver, 0, $val+1);
	      } else {
	         $ver = false;
	      }
			return $ver;
		}
		
		// PROTECTED - _GetOperatingSystem()
		function _GetOperatingSystem()
		{
			if (eregi("win",$this->USER_AGENT))
			{
				$this->OS = "Windows";
				if ((eregi("Windows 95",$this->USER_AGENT)) || (eregi("Win95",$this->USER_AGENT))) {$this->OS_Version = "95";}
				elseif (eregi("Windows ME",$this->USER_AGENT) || (eregi("Win 9x 4.90",$this->USER_AGENT))) {$this->OS_Version = "ME";}
				elseif ((eregi("Windows 98",$this->USER_AGENT)) || (eregi("Win98",$this->USER_AGENT))) {$this->OS_Version = "98";}
				elseif ((eregi("Windws NT 5.0",$this->USER_AGENT)) || (eregi("WinNT5.0",$this->USER_AGENT)) || (eregi("Windows 2000",$this->USER_AGENT)) || (eregi("Win2000",$this->USER_AGENT))) {$this->OS_Version = "2000";}
				elseif ((eregi("Windows NT 5.1",$this->USER_AGENT)) || (eregi("WinNT5.1",$this->USER_AGENT)) || (eregi("Windows XP",$this->USER_AGENT))) {$this->OS_Version = "XP";}
				elseif ((eregi("Windows NT 5.2",$this->USER_AGENT)) || (eregi("WinNT5.2",$this->USER_AGENT))) {$this->OS_Version = ".NET 2003";}
				elseif ((eregi("Windows NT 6.0",$this->USER_AGENT)) || (eregi("WinNT6.0",$this->USER_AGENT))) {$this->OS_Version = "Vista";}
				elseif (eregi("Windows CE",$this->USER_AGENT)) {$this->OS_Version = "CE";}
				elseif (eregi("Win3.11",$this->USER_AGENT)) {$this->OS_Version = "3.11";}
				elseif (eregi("Win3.1",$this->USER_AGENT)) {$this->OS_Version = "3.1";}
				elseif ((eregi("Windows NT",$this->USER_AGENT)) || (eregi("WinNT",$this->USER_AGENT))) {$this->OS_Version = "NT";}
			}
			elseif (eregi("lindows",$this->USER_AGENT))
			{
				$this->OS = "LindowsOS";
			}
			elseif (eregi("mac",$this->USER_AGENT))
			{
				$this->OS = "Macintosh";
				if ((eregi("Mac OS X",$this->USER_AGENT)) || (eregi("Mac 10",$this->USER_AGENT))) {$this->OS_Version = "OS X";}
				elseif ((eregi("PowerPC",$this->USER_AGENT)) || (eregi("PPC",$this->USER_AGENT))) {$this->OS_Version = "PPC";}
				elseif ((eregi("68000",$this->USER_AGENT)) || (eregi("68k",$this->USER_AGENT))) {$this->OS_Version = "68K";}
			}
			elseif (eregi("linux",$this->USER_AGENT))
			{
				$this->OS = "Linux";
				if (eregi("i686",$this->USER_AGENT)) {$this->OS_Version = "i686";}
				elseif (eregi("i586",$this->USER_AGENT)) {$this->OS_Version = "i586";}
				elseif (eregi("i486",$this->USER_AGENT)) {$this->OS_Version = "i486";}
				elseif (eregi("i386",$this->USER_AGENT)) {$this->OS_Version = "i386";}
				elseif (eregi("ppc",$this->USER_AGENT)) {$this->OS_Version = "ppc";}
				
				//distros
				if (eregi("ubuntu",$this->USER_AGENT)) {$this->OS_Distro = "Ubuntu";}
				
			}
			elseif (eregi("sunos",$this->USER_AGENT))
			{
				$this->OS = "SunOS";
			}
			elseif (eregi("hp-ux",$this->USER_AGENT))
			{
				$this->OS = "HP-UX";
			}
			elseif (eregi("osf1",$this->USER_AGENT))
			{
				$this->OS = "OSF1";
			}
			elseif (eregi("freebsd",$this->USER_AGENT))
			{
				$this->OS = "FreeBSD";
				if (eregi("i686",$this->USER_AGENT)) {$this->OS_Version = "i686";}
				elseif (eregi("i586",$this->USER_AGENT)) {$this->OS_Version = "i586";}
				elseif (eregi("i486",$this->USER_AGENT)) {$this->OS_Version = "i486";}
				elseif (eregi("i386",$this->USER_AGENT)) {$this->OS_Version = "i386";}
			}
			elseif (eregi("netbsd",$this->USER_AGENT))
			{
				$this->OS = "NetBSD";
				if (eregi("i686",$this->USER_AGENT)) {$this->OS_Version = "i686";}
				elseif (eregi("i586",$this->USER_AGENT)) {$this->OS_Version = "i586";}
				elseif (eregi("i486",$this->USER_AGENT)) {$this->OS_Version = "i486";}
				elseif (eregi("i386",$this->USER_AGENT)) {$this->OS_Version = "i386";}
			}
			elseif (eregi("irix",$this->USER_AGENT))
			{
				$this->OS = "IRIX";
			}
			elseif (eregi("os/2",$this->USER_AGENT))
			{
				$this->OS = "OS/2";
				if (eregi("Warp 4.5",$this->USER_AGENT)) {$this->OS_Version = "Warp 4.5";}
				elseif (eregi("Warp 4",$this->USER_AGENT)) {$this->OS_Version = "Warp 4";}
			}
			elseif (eregi("amiga",$this->USER_AGENT))
			{
				$this->OS = "Amiga";
			}
			elseif (eregi("liberate",$this->USER_AGENT))
			{
				$this->OS = "Liberate";
			}
			elseif (eregi("qnx",$this->USER_AGENT))
			{
				$this->OS = "QNX";
				if (eregi("photon",$this->USER_AGENT)) {$this->OS_Version = "Photon";}
			}
			elseif (eregi("dreamcast",$this->USER_AGENT))
			{
				$this->OS = "Sega Dreamcast";
			}
			elseif (eregi("palm",$this->USER_AGENT))
			{
				$this->OS = "Palm";
			}
			elseif (eregi("powertv",$this->USER_AGENT))
			{
				$this->OS = "PowerTV";
			}
			elseif (eregi("prodigy",$this->USER_AGENT))
			{
				$this->OS = "Prodigy";
			}
			elseif (eregi("symbian",$this->USER_AGENT))
			{
				$this->OS = "Symbian";
				if (eregi("symbianos/6.1",$this->USER_AGENT)) {$this->Browser_Version = "6.1";}
			}
			elseif (eregi("unix",$this->USER_AGENT))
			{
				$this->OS = "Unix";
			}
			elseif (eregi("webtv",$this->USER_AGENT))
			{
				$this->OS = "WebTV";
			}
			elseif (eregi("sie-cx35",$this->USER_AGENT))
			{
				$this->OS = "Siemens CX35";
			}
		}
				
		// PROTECTED - _GetBrowser()
		function _GetBrowser()
		{
			// BOTs
			if (eregi("msnbot",$this->USER_AGENT))
			{
				$this->Browser = "MSN Bot";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("msnbot");
			}
			elseif (eregi("abcdatos",$this->USER_AGENT))
			{
				$this->Browser = "ABCdatos BotLink";
				$this->Type = "robot";
				$this->Browser_Version = $this->_GetBrowserVersion("BotLink");
			}
			elseif (eregi("acme.spider",$this->USER_AGENT))
			{
				$this->Browser = "Acme.Spider";
				$this->Type = "robot";
				$this->Browser_Version = $this->_GetBrowserVersion("spider");
			}
			elseif (eregi("ahoy!",$this->USER_AGENT))
			{
				$this->Browser = "Ahoy! The Homepage Finder";
				$this->Type = "robot";
				$this->Browser_Version = $this->_GetBrowserVersion("finder");
			}
			elseif (eregi("AlkalineBOT",$this->USER_AGENT))
			{
				$this->Browser = "AlkalineBOT";
				$this->Type = "robot";
				$this->Browser_Version = $this->_GetBrowserVersion("AlkalineBOT");
			}
			elseif (eregi("Anthill",$this->USER_AGENT))
			{
				$this->Browser = "Anthill";
				$this->Type = "robot";
				$this->Browser_Version = $this->_GetBrowserVersion("AnthillV");
			}
			elseif (eregi("almaden",$this->USER_AGENT))
			{
				$this->Browser = "IBM Almaden Crawler";
				$this->Type = "robot";
			}
			elseif (eregi("BecomeBot",$this->USER_AGENT))
			{
				$this->Browser = "BecomeBot";
				$this->Type = "robot";
				$this->Browser_Version = $this->_GetBrowserVersion("becomebot");
			}
			elseif (eregi("BlitzBOT",$this->USER_AGENT))
			{
				$this->Browser = "BlitzBOT";
				$this->Type = "robot";
			}
			elseif (eregi("BumbleBee",$this->USER_AGENT))
			{
				$this->Browser = "BumbleBee";
				$this->Type = "robot";
				$this->Browser_Version = $this->_GetBrowserVersion("bumblebee");
			}
			elseif (eregi("CazoodleBot",$this->USER_AGENT))
			{
				$this->Browser = "CazoodleBot Crawler";
				$this->Type = "robot";
				if (eregi("Nutch-0.9-dev",$this->USER_AGENT)) {$this->Browser_Version = "0.9";}
			}
			elseif (eregi("Link-Checker-Pro",$this->USER_AGENT))
			{
				$this->Browser = "Link Checker Pro";
				$this->Type = "robot";
			}
			elseif (eregi("ia_archiver",$this->USER_AGENT))
			{
				$this->Browser = "Alexa";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("ia_archiver");
			}
			elseif ((eregi("googlebot",$this->USER_AGENT)) || (eregi("google",$this->USER_AGENT)) || (eregi("googlebot-w",$this->USER_AGENT)))
			{
				$this->Browser = "Google Bot";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("googlebot");
			}
			elseif (eregi("googlebot-image",$this->USER_AGENT))
			{
				$this->Browser = "Google Bot Image";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("googlebot-image");
			}
			elseif (eregi("kit-fireball",$this->USER_AGENT))
			{
				$this->Browser = "KIT-Fireball";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("kit-fireball");
			}
			elseif (eregi("ask jeeves",$this->USER_AGENT))
			{
				$this->Browser = "Ask Jeeves";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("mozilla");
			}
			elseif (eregi("indy library",$this->USER_AGENT))
			{
				$this->Browser = "Indy Library";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("mozilla");
			}
			elseif (eregi("girafabot",$this->USER_AGENT))
			{
				$this->Browser = "Girafabot";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("mozilla");
			}
			elseif (eregi("robozilla",$this->USER_AGENT))
			{
				$this->Browser = "Robozilla";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("robozilla");
			}
			elseif (eregi("scooter-w3",$this->USER_AGENT))
			{
				$this->Browser = "Altavista";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("scooter-w3");
			}
			elseif (eregi("steeler",$this->USER_AGENT))
			{
				$this->Browser = "Kitsuregawa Laboratory, University of Tokyo";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("steeler");
			}
			elseif (eregi("szukacz",$this->USER_AGENT))
			{
				$this->Browser = "Szukacz";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("szukacz");
			}
			elseif (eregi("tecomac-crawler",$this->USER_AGENT))
			{
				$this->Browser = "TECOMAC-Crawler";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("tecomac-crawler");
			}
			elseif (eregi("tricusbot",$this->USER_AGENT))
			{
				$this->Browser = "TricusBOT";
				$this->Type = "robot";
			}
			elseif (eregi("intkomi",$this->USER_AGENT))
			{
				$this->Browser = "Intkomi";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("mozilla");
			}
			elseif (eregi("surveybot",$this->USER_AGENT))
			{
				$this->Browser = "Survey Bot";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("surveybot");
			}
			elseif (eregi("zyborg",$this->USER_AGENT))
			{
				$this->Browser = "ZyBorg";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("zyborg");
			}
			elseif (eregi("w3c-checklink",$this->USER_AGENT))
			{
				$this->Browser = "W3C Checklink";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("checklink");
			}
			elseif (eregi("linkwalker",$this->USER_AGENT))
			{
				$this->Browser = "LinkWalker";
				$this->Type = "robot";
			}
			elseif (eregi("fast-webcrawler",$this->USER_AGENT))
			{
				$this->Browser = "Fast WebCrawler";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("webcrawler");
			}
			elseif ((eregi("yahoo",$this->USER_AGENT)) && (eregi("slurp",$this->USER_AGENT)))
			{
				$this->Browser = "Yahoo! Slurp";
				$this->Type = "robot";
			}
			elseif (eregi("naverbot",$this->USER_AGENT))
			{
				$this->Browser = "NaverBot";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("dloader");
			}
			elseif (eregi("converacrawler",$this->USER_AGENT))
			{
				$this->Browser = "ConveraCrawler";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("converacrawler");
			}
			elseif (eregi("innerprisebot",$this->USER_AGENT))
			{
				$this->Browser = "Innerprise";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("innerprise");
			}
			elseif (eregi("topicspy",$this->USER_AGENT))
			{
				$this->Browser = "Topicspy Checkbot";
				$this->Type = "robot";
			}
			elseif (eregi("poodle predictor",$this->USER_AGENT))
			{
				$this->Browser = "Poodle Predictor";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("poodle predictor");
			}
			elseif (eregi("ichiro",$this->USER_AGENT))
			{
				$this->Browser = "Ichiro";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("ichiro");
			}
			elseif (eregi("link checker pro",$this->USER_AGENT))
			{
				$this->Browser = "Link Checker Pro";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("link checker pro");
			}
			elseif (eregi("grub-client",$this->USER_AGENT))
			{
				$this->Browser = "Grub client";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("grub-client");
			}
			elseif (eregi("gigabot",$this->USER_AGENT))
			{
				$this->Browser = "Gigabot";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("gigabot");
			}
			elseif (eregi("psbot",$this->USER_AGENT))
			{
				$this->Browser = "PSBot";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("psbot");
			}
			elseif (eregi("mj12bot",$this->USER_AGENT))
			{
				$this->Browser = "MJ12Bot";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("mj12bot");
			}
			elseif (eregi("nextgensearchbot",$this->USER_AGENT))
			{
				$this->Browser = "NextGenSearchBot";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("nextgensearchbot");
			}
			elseif (eregi("tutorgigbot",$this->USER_AGENT))
			{
				$this->Browser = "TutorGigBot";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("bot");
			}
			elseif (ereg("NG",$this->USER_AGENT))
			{
				$this->Browser = "Exabot NG";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("ng");
			}
			elseif (eregi("gaisbot",$this->USER_AGENT))
			{
				$this->Browser = "Gaisbot";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("gaisbot");
			}
			elseif (eregi("xenu link sleuth",$this->USER_AGENT))
			{
				$this->Browser = "Xenu Link Sleuth";
				$this->Type = "robot";
            $this->Browser_Version =$this->_GetBrowserVersion("xenu link sleuth");
			}
			elseif (eregi("turnitinbot",$this->USER_AGENT))
			{
				$this->Browser = "TurnitinBot";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("turnitinbot");
			}
			elseif (eregi("iconsurf",$this->USER_AGENT))
			{
				$this->Browser = "IconSurf";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("iconsurf");
			}
			elseif (eregi("zoe indexer",$this->USER_AGENT))
			{
				$this->Browser = "Zoe Indexer";
				$this->Type = "robot";
				if (eregi("v1.x",$this->USER_AGENT)) {$this->Browser_Version = "1";}
			}
			elseif (eregi("FeedDemon",$this->USER_AGENT))
			{
				$this->Browser = "Feed Demon";
				$this->Type = "robot";
            $this->Browser_Version = $this->_GetBrowserVersion("freedemon");
			}
			//Validators
			elseif (eregi("w3c_validator",$this->USER_AGENT))
			{
				$this->Browser = "W3C Validator";
				$this->Type = "validator";
            $this->Browser_Version = $this->_GetBrowserVersion("w3c_validator");
			}
			elseif (eregi("Jigsaw",$this->USER_AGENT))
			{
				$this->Browser = "Jigsaw CSS Validator";
				$this->Type = "validator";
            $this->Browser_Version = $this->_GetBrowserVersion("Jigsaw");
			}
			elseif (eregi("php",$this->USER_AGENT))
			{
				$this->Browser = "PHP Online Validator";
				$this->Type = "validator";
            $this->Browser_Version = $this->_GetBrowserVersion("php");
			}
			elseif (eregi("WDG_Validator",$this->USER_AGENT))
			{
				$this->Browser = "WDG Validator";
				$this->Type = "validator";
            $this->Browser_Version = $this->_GetBrowserVersion("WDG_Validator");
			}
			//Download Tools
			elseif (eregi("downloadaccelerator",$this->USER_AGENT))
			{
				$this->Browser = "Download Accelerator";
				$this->Type = "dltool";
            $this->Browser_Version = $this->_GetBrowserVersion("da");
			}						
			elseif (eregi("Download Express",$this->USER_AGENT))
			{
				$this->Browser = "Download Express";
				$this->Type = "dltool";
            $this->Browser_Version = $this->_GetBrowserVersion("Download Express");
			}						
			elseif (eregi("FlashGet",$this->USER_AGENT))
			{
				$this->Browser = "FlashGet";
				$this->Type = "dltool";
			}						
			elseif (eregi("Anonymizer",$this->USER_AGENT))
			{
				$this->Browser = "GetRight";
				$this->Type = "dltool";
            $this->Browser_Version = $this->_GetBrowserVersion("Anonymizer");
			}						
			elseif (eregi("GetRight",$this->USER_AGENT))
			{
				$this->Browser = "GetRight";
				$this->Type = "dltool";
            $this->Browser_Version = $this->_GetBrowserVersion("GetRight");
			}						
			elseif (eregi("Go!Zilla",$this->USER_AGENT))
			{
				$this->Browser = "Go!Zilla";
				$this->Type = "dltool";
            $this->Browser_Version = $this->_GetBrowserVersion("Go!Zilla");
			}						
			elseif (eregi("wget",$this->USER_AGENT))
			{
				$this->Browser = "WGet";
				$this->Type = "dltool";
				$this->Browser_Version = $this->_GetBrowserVersion("wget");
			}
			//Other Tools
			elseif (eregi("cacheabilityengine",$this->USER_AGENT))
			{
				$this->Browser = "CacheabilityEngine";
				$this->Type = "tool";
            $this->Browser_Version = $this->_GetBrowserVersion("cacheabilityengine");
			}			
			elseif (eregi("InfoLink",$this->USER_AGENT))
			{
				$this->Browser = "InfoLink";
				$this->Type = "tool";
            $this->Browser_Version = $this->_GetBrowserVersion("InfoLink");
			}
			//Mailers that can display pages
			elseif (eregi("thunderbird",$this->USER_AGENT))
			{
				$this->Browser = "thunderbird";
				$this->Type = "mailer";
            $this->Browser_Version = $this->_GetBrowserVersion("thunderbird");
			}
			//WAP browsers
			elseif (eregi("kbrowser",$this->USER_AGENT))
			{
				$this->Browser = "kbrowser";
				$this->Type = "wapbrowser";
            $this->Browser_Version = $this->_GetBrowserVersion("kbrowser");
			}			
			elseif (eregi("Alcatel-BE3",$this->USER_AGENT))
			{
				$this->Browser = "Alcatel-BE3";
				$this->Type = "wapbrowser";
            $this->Browser_Version = $this->_GetBrowserVersion("up");
			}			
			elseif (eregi("Alcatel-BF3",$this->USER_AGENT))
			{
				$this->Browser = "Alcatel-BF3";
				$this->Type = "wapbrowser";
            $this->Browser_Version = $this->_GetBrowserVersion("up.browser");
			}			
			elseif (eregi("Alcatel-BE4",$this->USER_AGENT))
			{
				$this->Browser = "Alcatel-BE4";
				$this->Type = "wapbrowser";
            $this->Browser_Version = $this->_GetBrowserVersion("up");
			}			
			elseif (eregi("Alcatel-BF4",$this->USER_AGENT))
			{
				$this->Browser = "Alcatel-BF4";
				$this->Type = "wapbrowser";
            $this->Browser_Version = $this->_GetBrowserVersion("up.browser");
			}			
			elseif (eregi("Alcatel-BE5",$this->USER_AGENT))
			{
				$this->Browser = "Alcatel-BE5";
				$this->Type = "wapbrowser";
            $this->Browser_Version = $this->_GetBrowserVersion("up");
			}			
			elseif (eregi("AUR PALM WAPPER",$this->USER_AGENT))
			{
				$this->Browser = "AU-System";
				$this->Type = "wapbrowser";
            $this->Browser_Version = $this->_GetBrowserVersion("(WAP");
			}			
			elseif (eregi("EricssonA",$this->USER_AGENT))
			{
				$this->Browser = "Ericsson";
				$this->Type = "wapbrowser";
            $this->Browser_Version = $this->_GetBrowserVersion("EricssonA");
			}			
			elseif (eregi("EricssonR",$this->USER_AGENT))
			{
				$this->Browser = "Ericsson";
				$this->Type = "wapbrowser";
            $this->Browser_Version = $this->_GetBrowserVersion("EricssonR");
			}			
			elseif (eregi("EricssonT",$this->USER_AGENT))
			{
				$this->Browser = "Ericsson";
				$this->Type = "wapbrowser";
            $this->Browser_Version = $this->_GetBrowserVersion("EricssonT");
			}			
			elseif (eregi("Mitsu",$this->USER_AGENT))
			{
				$this->Browser = "Mitsubishi";
				$this->Type = "wapbrowser";
            $this->Browser_Version = $this->_GetBrowserVersion("Mitsu");
			}			
			elseif (eregi("Benefon",$this->USER_AGENT))
			{
				$this->Browser = "Benefon";
				$this->Type = "wapbrowser";
            $this->Browser_Version = $this->_GetBrowserVersion("Mozilla");
			}			
			elseif (eregi("Sony CMD",$this->USER_AGENT))
			{
				$this->Browser = "Sony CMD";
				$this->Type = "wapbrowser";
            $this->Browser_Version = $this->_GetBrowserVersion("Sony CMD");
			}			
			elseif (eregi("Nokia",$this->USER_AGENT))
			{
				$this->Browser = "Nokia";
				$this->Type = "wapbrowser";
            $this->Browser_Version = $this->_GetBrowserVersion("Nokia");
			}			
			elseif (eregi("Panasonic",$this->USER_AGENT))
			{
				$this->Browser = "Panasonic GAD";
				$this->Type = "wapbrowser";
            $this->Browser_Version = $this->_GetBrowserVersion("Panasonic-GAD");
			}			
			elseif (eregi("SIE-C3I",$this->USER_AGENT))
			{
				$this->Browser = "Siemens C35";
				$this->Type = "wapbrowser";
            $this->Browser_Version = $this->_GetBrowserVersion("SIE-C3I");
			}			
			elseif (eregi("Google WAP Proxy",$this->USER_AGENT))
			{
				$this->Browser = "Google WAP Proxy";
				$this->Type = "wapbrowser";
            $this->Browser_Version = $this->_GetBrowserVersion("Google WAP Proxy");
			}			
			//Browsers
			elseif (eregi("amaya",$this->USER_AGENT))
			{
				$this->Browser = "amaya";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("amaya");
			}
			elseif ((eregi("aol",$this->USER_AGENT)) && !(eregi("msie",$this->USER_AGENT)))
			{
				$this->Browser = "AOL";
				$this->Type = "browser";
	         $this->Browser_Version = $this->_GetBrowserVersion("aol");
			}
			elseif (eregi("aweb",$this->USER_AGENT))
			{
				$this->Browser = "AWeb";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("aweb");
			}
			elseif (eregi("voyager",$this->USER_AGENT))
			{
				$this->Browser = "Voyager";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("voyager");
			}
			elseif (eregi("ibrowse",$this->USER_AGENT))
			{
				$this->Browser = "iBrowse";
            $this->Browser_Version = $this->_GetBrowserVersion("ibrowse");
			}
			elseif (eregi("beonex",$this->USER_AGENT))
			{
				$this->Browser = "Beonex";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("beonex");
			}
			elseif (eregi("camino",$this->USER_AGENT))
			{
				$this->Browser = "Camino";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("camino");
			}
			elseif (eregi("cyberdog",$this->USER_AGENT))
			{
				$this->Browser = "Cyberdog";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("cyberdog");
			}
			elseif (eregi("dillo",$this->USER_AGENT))
			{
				$this->Browser = "Dillo";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("dillo");
			}
			elseif (eregi("doris",$this->USER_AGENT))
			{
				$this->Browser = "Doris";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("doris");
			}
			elseif (eregi("emacs",$this->USER_AGENT))
			{
				$this->Browser = "Emacs";
				$this->Type = "browser";
				if (eregi("emacs/w3/2",$this->USER_AGENT)) {$this->Browser_Version = "2";}
				elseif (eregi("emacs/w3/3",$this->USER_AGENT)) {$this->Browser_Version = "3";}
				elseif (eregi("emacs/w3/4",$this->USER_AGENT)) {$this->Browser_Version = "4";}
			}
			elseif (eregi("firebird",$this->USER_AGENT))
			{
				$this->Browser = "Firebird";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("firebird");
			}
			elseif (eregi("firefox",$this->USER_AGENT))
			{
				$this->Browser = "Firefox";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("firefox");
			}
			elseif (eregi("frontpage",$this->USER_AGENT))
			{
				$this->Browser = "FrontPage";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("frontpage");
				if ((eregi("express 2",$this->USER_AGENT)) || (eregi("frontpage 2",$this->USER_AGENT))) {$this->Browser_Version = "2";}
			}
			elseif (eregi("galeon",$this->USER_AGENT))
			{
				$this->Browser = "Galeon";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("galeon");
			}
			elseif (eregi("ibm web browser",$this->USER_AGENT))
			{
				$this->Browser = "IBM Web Browser";
				$this->Type = "browser";
				if (eregi("rv:1.0.1",$this->USER_AGENT)) {$this->Browser_Version = "1.0.1";}
			}
			elseif (eregi("chimera",$this->USER_AGENT))
			{
				$this->Browser = "Chimera";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("chimera");
			}
			elseif (eregi("icab",$this->USER_AGENT))
			{
				$this->Browser = "iCab";
        		$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("icab");
			}
			elseif (eregi("konqueror",$this->USER_AGENT))
			{
				$this->Browser = "Konqueror";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("konqueror");
			}
			elseif (eregi("liberate",$this->USER_AGENT))
			{
				$this->Browser = "Liberate";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("dtv");
			}
			elseif (eregi("desktop/lx",$this->USER_AGENT))
			{
				$this->Browser = "Lycoris Desktop/LX";
				$this->Type = "browser";
			}
			elseif (eregi("netbox",$this->USER_AGENT))
			{
				$this->Browser = "NetBox";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("netbox");
			}
			elseif (eregi("netcaptor",$this->USER_AGENT))
			{
				$this->Browser = "Netcaptor";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("netscaptor");
			}
			elseif (eregi("netpliance",$this->USER_AGENT))
			{
				$this->Browser = "Netpliance";
				$this->Type = "browser";
			}
 			//added by wooya		
			elseif (eregi("netscape6",$this->USER_AGENT)) // (1) netscape nie je prilis detekovatelny....
			{
				$this->Browser = "Netscape";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("netscape6");
			}
 			//added by wooya		
			elseif (eregi("netscape",$this->USER_AGENT)) // (1) netscape nie je prilis detekovatelny....
			{
				$this->Browser = "Netscape";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("netscape");
			}
			elseif ((eregi("mozilla/5.0",$this->USER_AGENT)) && (eregi("rv:",$this->USER_AGENT)) && (eregi("gecko/",$this->USER_AGENT))) // mozilla je troschu zlozitejsia na detekciu
			{
				$this->Browser = "Mozilla";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("rv");
			}
			elseif (eregi("offbyone",$this->USER_AGENT))
			{
				$this->Browser = "OffByOne";
				$this->Type = "browser";
				$this->Browser_Version = $this->_GetBrowserVersion("mozilla");
			}
			elseif (eregi("omniweb",$this->USER_AGENT))
			{
				$this->Browser = "OmniWeb";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("omniweb");
			}
			elseif (eregi("opera",$this->USER_AGENT))
			{
				$this->Browser = "Opera";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("opera");
			}
			elseif (eregi("oracle",$this->USER_AGENT))
			{
				$this->Browser = "Oracle PowerBrowser";
				$this->Type = "browser";
				if (eregi("(tm)/1.0a",$this->USER_AGENT)) {$this->Browser_Version = "1.0a";}
				elseif (eregi("oracle 1.5",$this->USER_AGENT)) {$this->Browser_Version = "1.5";}
			}
			elseif (eregi("phoenix",$this->USER_AGENT))
			{
				$this->Browser = "Phoenix";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("phoenix");
			}
			elseif (eregi("planetweb",$this->USER_AGENT))
			{
				$this->Browser = "PlanetWeb";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("planetweb");
			}
			elseif (eregi("powertv",$this->USER_AGENT))
			{
				$this->Browser = "PowerTV";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("powertv");
			}
			elseif (eregi("prodigy",$this->USER_AGENT))
			{
				$this->Browser = "Prodigy";
				$this->Type = "browser";
				if (eregi("wb/3.2e",$this->USER_AGENT)) {$this->Browser_Version = "3.2e";}
				elseif (eregi("rv: 1.",$this->USER_AGENT)) {$this->Browser_Version = "1.0";}
			}
			elseif ((eregi("voyager",$this->USER_AGENT)) || ((eregi("qnx",$this->USER_AGENT))) && (eregi("rv: 1.",$this->USER_AGENT))) // aj voyager je trosku zlozitejsi na detekciu
			{
				$this->Browser = "Voyager";
        $this->Type = "browser";
				if (eregi("2.03b",$this->USER_AGENT)) {$this->Browser_Version = "2.03b";}
				elseif (eregi("wb/win32/3.4g",$this->USER_AGENT)) {$this->Browser_Version = "3.4g";}
			}
			elseif (eregi("quicktime",$this->USER_AGENT))
			{
				$this->Browser = "QuickTime";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("qtver");
			}
			elseif (eregi("safari",$this->USER_AGENT))
			{
				$this->Browser = "Safari";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("safari");
			}
			elseif (eregi("sextatnt",$this->USER_AGENT))
			{
				$this->Browser = "Tango";
				$this->Type = "browser";
				if (eregi("sextant v3.0",$this->USER_AGENT)) {$this->Browser_Version = "3.0";}
			}
			elseif (eregi("sharpreader",$this->USER_AGENT))
			{
				$this->Browser = "SharpReader";
				$this->Type = "browser";
				if (eregi("sharpreader/0.9.5",$this->USER_AGENT)) {$this->Browser_Version = "0.9.5";}
			}
			elseif (eregi("elinks",$this->USER_AGENT))
			{
				$this->Browser = "ELinks";
				$this->Type = "browser";
				if (eregi("0.3",$this->USER_AGENT)) {$this->Browser_Version = "0.3";}
				elseif (eregi("0.4",$this->USER_AGENT)) {$this->Browser_Version = "0.4";}
				elseif (eregi("0.9",$this->USER_AGENT)) {$this->Browser_Version = "0.9";}
			}
			elseif (eregi("links",$this->USER_AGENT))
			{
				$this->Browser = "Links";
				$this->Type = "browser";
				if (eregi("0.9",$this->USER_AGENT)) {$this->Browser_Version = "0.9";}
				elseif (eregi("2.0",$this->USER_AGENT)) {$this->Browser_Version = "2.0";}
				elseif (eregi("2.1",$this->USER_AGENT)) {$this->Browser_Version = "2.1";}
			}
			elseif (eregi("lynx",$this->USER_AGENT))
			{
				$this->Browser = "Lynx";
				$this->Type = "browser";
				$this->Browser_Version = $this->_GetBrowserVersion("lynx");
			}
			elseif (eregi("webexplorer",$this->USER_AGENT))
			{
				$this->Browser = "WebExplorer";
				$this->Type = "browser";
				if (eregi("dll/v1.1",$this->USER_AGENT)) {$this->Browser_Version = "1.1";}
			}
			elseif (eregi("webtv",$this->USER_AGENT))
			{
				$this->Browser = "WebTV";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("webtv");
			}
			elseif (eregi("yandex",$this->USER_AGENT))
			{
				$this->Browser = "Yandex";
				$this->Type = "browser";
				if (eregi("/1.01",$this->USER_AGENT)) {$this->Browser_Version = "1.01";}
				elseif (eregi("/1.03",$this->USER_AGENT)) {$this->Browser_Version = "1.03";}
			}
			elseif ((eregi("mspie",$this->USER_AGENT)) || ((eregi("msie",$this->USER_AGENT))) && (eregi("windows ce",$this->USER_AGENT)))
			{
				$this->Browser = "Pocket Internet Explorer";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("mspie");
			}
			elseif (eregi("UP.Browser/",$this->USER_AGENT))
			{
				$this->Browser = "UP Browser";
				$this->Type = "browser";
				$this->Browser_Version = $this->_GetBrowserVersion("browser");
			}
			elseif (eregi("msie",$this->USER_AGENT))
			{
				$this->Browser = "Internet Explorer";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("msie");
			}
			elseif (eregi("iexplore",$this->USER_AGENT))
			{
				$this->Browser = "Internet Explorer";
				$this->Type = "browser";
			}
			elseif (eregi("mozilla",$this->USER_AGENT)) // (2) netscape nie je prilis detekovatelny....
			{
				$this->Browser = "Netscape";
				$this->Type = "browser";
            $this->Browser_Version = $this->_GetBrowserVersion("mozilla");
			}
		}
	}
?>