<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: new_infusion_panel.php
| Author: INSERT NAME HERE
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

include INFUSIONS."wooya_web_stats_panel/infusion_db.php";

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."wooya_web_stats_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."wooya_web_stats_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."wooya_web_stats_panel/locale/English.php";
}

$web_stats = dbarray(dbquery("SELECT stats_enabled FROM ".DB_WWSP_CONFIG));
if ($web_stats['stats_enabled']==1) {
	if (checkrights("IP")) {
		openside($locale['ws400']);
		echo "<div class='quote' style='text-align:center;font-weight:bold;color:green'>".$locale['WEB_STATS_ON']."</div>";
		closeside();
	}

	include_once INFUSIONS."wooya_web_stats_panel/includes/class.browser_info.php";
	include_once INFUSIONS."wooya_web_stats_panel/includes/i2m.class.php";

	$i2m = new ip2more(USER_IP, true);
	$i2m->flags_dir = INFUSIONS."wooya_web_stats_panel/includes/flags/";
	define ("USER_COUNTRY1", $i2m->country['name']);
	define ("USER_COUNTRY2", $i2m->country['iso2']);
	define ("USER_COUNTRY3", $i2m->country['iso3']);
	define ("USER_CAPITAL", $i2m->country['capital']);
	define ("USER_REGION", $i2m->country['region']);
	define ("USER_CURRENCY", $i2m->country['currency']);
	define ("USER_CURRENCY_CODE", $i2m->country['currency_code']);
	/*define ("USER_LANGUAGES", $i2m->country['languages']);
	$country_languages = explode("+",USER_LANGUAGES);
	for ($i=0;$i<sizeof($country_languages);$i++) {
	   if (!defined("STATS_LANGUAGE")) {
	      define ("STATS_LANGUAGE", $country_languages[$i]);
	   }
	}*/
	if (!defined("STATS_LANGUAGE")) {
	   define ("STATS_LANGUAGE", $settings['locale']);
	}

	$HTTPVIA = array_key_exists('HTTP_VIA', $_SERVER)?$_SERVER['HTTP_VIA']:false;
	$HTTPFORWARD = array_key_exists('HTTP_X_FORWARDED_FOR', $_SERVER)?$_SERVER['HTTP_X_FORWARDED_FOR']:false;
	$HTTPREFERER = array_key_exists('HTTP_REFERER', $_SERVER)?$_SERVER['HTTP_REFERER']:'unknown';
	$HTTPREQUEST = FUSION_REQUEST;
	$HTTPUSAGENT = $_SERVER['HTTP_USER_AGENT'];
	$HTTPPROXY = null;
	$PROXYSERV = null;

	$GUESTIP = USER_IP;
	$REFERER = null;
	$PAGE = null;
	$COUNTRY = null;
	$PROVIDER = null;
	$BROWSER = null;
	$TYPE = null;
	$OS = null;
	$DISTRO = null;
	$BOT = null;
	$VERSION = null;
	$LANGUAGE = STATS_LANGUAGE!=''?STATS_LANGUAGE:$settings['locale'];
	$USERID = null;

	$ref = parse_url($HTTPREFERER)?parse_url($HTTPREFERER):'';
	if (array_key_exists('host', $ref)) {
	   $REFERER = $ref['scheme']."://".$ref['host'];
	} else {
	   $REFERER = 'unknown';
	}

	//get visited page
	$pag = parse_url($HTTPREQUEST)?parse_url($HTTPREQUEST):false;
	if (trim(substr($pag['path'], 1))!='') {
	   $PAGE = substr($pag['path'], 1).(isset($pag['query'])?"?".$pag['query']:"");
	} else {
	   $PAGE = "index.php";
	}

	if ($HTTPVIA) {
	   if (isNum(str_replace(".", "", $HTTPFORWARD))) {
	      $GUESTIP = gethostbyaddr($HTTPFORWARD);
	   }
	   $result = explode(' ',$HTTPVIA);
	   if (strpos($result[1],':')) { 
	      $result[1] = substr($result[1],0,strpos($result[1],':')); 
	   }
	   $HTTPPROXY = gethostbyname($result[1]);
	   $PROXYSERV = $result[2];
	}

	//we are in local server
	if ($GUESTIP == "127.0.0.1"){
	   $COUNTRY = "--";
	   $PROVIDER = "localhost";
	} else {
	   $COUNTRY = USER_COUNTRY2;
	}

	//now identify if it's a user or visitor
	if (iGUEST) {
	  $USERID = 0;
	} else {
	  $USERID = $userdata['user_id'];
	}

	//get browser info
	$browser_info = new BrowserInfo($HTTPUSAGENT);
	$resolved = $browser_info->Resolved;

	$DISTRO = $browser_info->OS_Distro!=''?$browser_info->OS_Distro." ":"";
	$OS = $DISTRO.$browser_info->OS." ".$browser_info->OS_Version;
	$BROWSER = $browser_info->Browser;
	$BROWSER .= trim($browser_info->Browser_Version)!=''?" [".$browser_info->Browser_Version."]":"";

	if ($browser_info->Type=="robot") {
	   $TYPE="bot";
	} else if ($browser_info->Type=="validator") {
	   $TYPE="validator";
	} else if ($browser_info->Type=="dltool") {
	   $TYPE="dltool";
	} else if ($browser_info->Type=="tool") {
	   $TYPE="tool";
	} else if ($browser_info->Type=="mailer") {
	   $TYPE="mailer";
	} else if ($browser_info->Type=="browser") {
	   $TYPE="browser";
	} else if ($browser_info->Type=="wapbrowser") {
	   $TYPE="wapbrowser";
	} else {
	   $TYPE="unknown";
	}
	 
	if (trim($OS)=='') $OS = 'unknown';
	if (trim($BROWSER)=='') $BROWSER = 'unknown';

	//simple array which tells as that provider is not a provider ;) Still builds...
	$notprovider = array('net', 'com', 'uk');
	//get provider
	$prov = explode('.', gethostbyaddr($GUESTIP));
	if($prov[0] == USER_IP || $prov[0] == gethostbyaddr($GUESTIP)){
	   $PROVIDER = 'unknown';
	} else {
	   $PROVIDER = $prov[(count($prov)-2)];
	   if (!in_array($PROVIDER, $notprovider)) {
	      $PROVIDER = $prov[(count($prov)-3)];
	   }
	}

	if (isNum(trim($PROVIDER))) $PROVIDER = 'unknown';

	//This is useless. It's just a fix for the poor ip2m database that is not upgraded'
	if (strtolower($PROVIDER) == "interbusiness") $COUNTRY = "IT";
	if (strtolower($PROVIDER) == "fastweb") $COUNTRY = "IT";
	if (strtolower($PROVIDER) == "fastres") $COUNTRY = "IT";

	if ($HTTPPROXY!='') $PROVIDER .= "<i><br>".$HTTPPROXY."<br>".$PROXYSERV."</i>";

	$hits_check = dbquery("SELECT hits FROM ".DB_WWSP_STATS." WHERE ip='".$GUESTIP."'");
	$hits = dbrows($hits_check);

	//do not show links in admin area
	$PAGE = (eregi("administration/", $PAGE)?"Admin Area":$PAGE);

	if($hits >= 1){
	    $total_hits = dbarray($hits_check);
	    $result = dbquery("UPDATE ".DB_WWSP_STATS." SET user_id='".$USERID."', os='".$OS."', hits='".($total_hits['hits']+1)."', time='".time()."', page='".$PAGE."', provider='".$PROVIDER."', day='".date('d')."', month='".date('m')."', year='".date('y')."', browser='".$BROWSER."', type='".$TYPE."', land='".$COUNTRY."', referer='".$REFERER."', site_language='".$LANGUAGE."' WHERE ip='".$GUESTIP."'");
	} else {
	    $result = dbquery("INSERT INTO ".DB_WWSP_STATS." (user_id, os, time, page, ip, provider, land, day, month, year, browser, type, referer, site_language) VALUES ('".$USERID."', '".$OS."', '".time()."', '".$PAGE."', '".$GUESTIP."', '".$PROVIDER."', '".$COUNTRY."', '".date('d')."', '".date('m')."', '".date('y')."', '".$BROWSER."', '".$TYPE."', '".$REFERER."', '".$LANGUAGE."')");
	}
} else {
	if (checkrights("IP")) {
	   openside($locale['ws400']);
	   echo "<div class='quote' style='text-align:center;font-weight:bold;color:red'>".$locale['WEB_STATS_OFF']."</div>";
	   closeside();
	}
}
?>